<?php
// display a link to contact the current blog owner
$Blog->contact_link( array(
	'before' => '',
	'after' => ' ',
	'text' => T_('Contact'),
	'title' => T_('Send a message to the owner of this blog...'),
) );

// display a link to this blog's credits page
$Blog->credits_link( array(
	'before' => '',
	'after' => ' ',
	'text' => T_('software credits'),
	'title' => T_('See who wrote the code that helps make this website'),
	'class' => '',
) );

// displays current blog's footer text
$Blog->footer_text( array(
	'before' => '',
	'after' => ' ',
) );

// displays current blog's long description
$Blog->longdesc( array(
	'before' => '',
	'after' => ' ',
	'format' => 'htmlbody',
) );

// displays current blog's (full) name
$Blog->name( array(
	'before' => '',
	'after' => ' ',
	'format' => 'htmlbody',
) );

// display the current blog's tagline
$Blog->tagline( array(
	'before' => '',
	'after' => ' ',
	'format' => 'htmlbody',
) );

$Comment->anchor(); // display an anchor for for this comment

// display comment author's name
$Comment->author( array(
	'before_visitor' => '',
	'after_visitor' => ' ['.T_('Visitor').']',
	'before_user' => '',
	'after_user' => ' ['.T_('Member').']',
	'format' => 'htmlbody',
	'make_link' => false,
) );

// display mailto link to comment author's email
$Comment->author_email( array(
	'before' => '',
	'after' => '',
	'text' => '',
	'make_link' => true,
) );

// display comment author's IP address
$Comment->author_ip( array(
	'before' => '',
	'after' => '',
) );

// display a link to comment author's URL
$Comment->author_url( array(
	'before' => '',
	'after' => '',
	'text' => '',
	'make_link' => true,
) );

$Comment->content(); // display the comment's contents

// display the comment's date
$Comment->date( array(
	'before' => '',
	'after' => '',
	'format' => locale_datefmt(),
	'useGM' => false,
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'before' => '',
	'after' => ' ',
	'text' => '#', // '#' = get_icon( 'delete', 'imgtag' ).' '.T_('Delete!')
	'title' => T_('Delete this comment'),
	'class' => '',
	'button' => false,
	'glue' => '&amp;',
	'save_context' => true,
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'before' => '',
	'after' => ' ',
	'text' => '#',
	'title' => T_('Delete this comment'),
	'class' => '',
	'button' => false,
	'glue' => '&amp;',
	'save_context' => true,
) );

// display a link to deprecate a comment
$Comment->deprecate_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'deprecate', 'imgtag' ).' '.T_('Deprecate!'),
	'title' => T_('Deprecate this comment!'),
	'class' => '',
	'glue' => '&amp;',
	'save_context' => true,
) );

// display a link to edit a comment
$Comment->edit_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'edit' ).' '.T_('Edit...'),
	'title' => T_('Edit this comment'),
	'class' => '',
	'glue' => '&amp;',
	'save_context' => true,
) );

// display a link to message form for this comment's author
$Comment->msgform_link( $Blog->get('msgformurl'), array(
	'before' => '',
	'after' => ' ',
	'text' => '#',
	'title' => T_('Send email to comment author'),
	'class' => '',
) );

// display a permalink link to the comment
$Comment->permanent_link( array(
	'before' => '',
	'after' => ' ',
	'text' => '#',
	'title' => T_('Permanent link to this comment'),
	'class' => '',
	'nofollow' => false,
) );

// display a link to publish a comment
$Comment->publish_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'publish', 'imgtag' ).' '.T_('Publish!'),
	'title' => T_('Publish this comment!'),
	'class' => '',
	'glue' => '&amp;',
	'save_context' => true,
) );

// display a comment's rating
$Comment->rating( array(
	'before' => '<div class="comment_rating">',
	'after' => '</div>',
	'star_class' => 'middle',
) );

// display options to rate a comment
$Comment->rating_input( array(
	'before' => '',
	'after' => '',
	'label_low' => T_('Poor'),
	'label_high' => T_('Excellent'),
) );

// display option to reset rating
$Comment->rating_none_input( array(
	'before' => '',
	'after' => '',
	'label' => T_('No rating'),
) );

// display the comment's time
$Comment->time( array(
	'before' => '',
	'after' => '',
	'format' => locale_datefmt(),
	'useGM' => false,
) );

$Item->anchor(); // displays anchor for permalinks

// typical use...
?>
<div id="<?php $Item->anchor_id(); ?>" lang="<?php $Item->lang(); ?>">
<?php

// display author/creator of item
$Item->author( array(
	'before' => '',
	'after' => ' ',
	'format' => 'htmlbody',
	'link_to' => 'userpage',
	'link_text' => 'preferredname',
	'link_rel' => '',
	'link_class' => '',
) );

// display and link categories by name
$Item->categories( array(
	'before' => '',
	'after' => ' ',
	'include_main' => true,
	'before_main' => '',
	'after_main' => '',
	'include_other' => true,
	'before_other' => '',
	'after_other' => '',
	'include_external' => true,
	'before_external' => '<em>',
	'after_external' => '</em>',
	'separator' => ', ',
	'link_categories' => true,
	'link_title' => T_('Browse category'),
	'format' => 'htmlbody',
	) );

// display content teaser of item
$Item->content_extension( array(
	'before' => '',
	'after' => '',
	'disppage' => '#',
	'format' => 'htmlbody',
	'force_more' => false,
) );

// display item's teaser
$Item->content_teaser( array(
	'before' => '',
	'after' => '',
	'disppage' => '#',
	'stripteaser' => '#',
	'format' => 'htmlbody',
) );

// increment view counter
$Item->count_view( array(
	'allow_multiple_counts_per_page' => false,
) );

// display a link to delete an item if user has edit rights
$Item->delete_link( array(
	'before' => '',
	'after' => ' ',
	'text' => '#',
	'title' => T_('Delete this post'),
	'class' => '',
	'button' => false,
	'action_url' => '#',
) );

// display a link to deprecate an item if user has edit rights
$Item->deprecate_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'deprecate', 'imgtag' ).' '.T_('Deprecate!'),
	'title' => T_('Deprecate this post!'),
	'class' => '',
	'glue' => '&amp;',
) );

// default values shown ...
$Item->div_classes( array(
	'item_class' => 'bPost',
	'item_type_class' => 'bPost_ptyp',
	'item_status_class' => 'bPost',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'edit' ).' '.T_('Edit...'),
	'title' => T_('Edit this post...'),
	'class' => '',
	'save_context' => true,
) );

// display link to (and count of) comments and trackbacks
$Item->feedback_link( array(
	'type' => 'feedbacks',
	'status' => 'published',
	'link_before' => '',
	'link_after' => '',
	'link_title' => '#',
	'link_text_zero' => '#',
	'link_text_one' => '#',
	'link_text_more' => '#',
	'link_anchor_zero' => '#',
	'link_anchor_one' => '#',
	'link_anchor_more' => '#',
	'use_popup' => false,
	'url' => '#',
) );

// display item's footer
$Item->footer( array(
	'mode' => '#',
	'block_start' => '<div class="item_footer">',
	'block_end' => '</div>',
	'format' => 'htmlbody',
) );

// display images linked to this item
$Item->images( array(
	'before' => '<div>',
	'after' => '</div>',
	'before_image' => '<div class="image_block">',
	'after_image' => '</div>',
	'before_image_legend' => '<div class="image_legend">',
	'after_image_legend' => '</div>',
	'image_size' => 'fit-400',
	'image_link_to' => 'original',
	'limit' => 1000,
) );

if(	$Item->is_featured() )
{
	echo 'do featured item stuff here';
}

if( $Item->is_intro() )
{
	echo 'do intro item stuff here';
}

// display issue date/time of item
$Item->issue_date( array(
	'before' => '',
	'after' => ' ',
	'date_format' => '#',
	'use_GMT' => false,
) );

// display issue date/time of item
$Item->issue_time( array(
	'before' => '',
	'after' => ' ',
	'time_format' => '#',
	'use_GMT' => false,
) );

// display the item's locale flag
$Item->locale_flag( array(
	'before' => '',
	'after' => ' ',
	'collection' => 'h10px',
	'format' => 'htmlbody',
	'class' => 'flag',
	'align' => '',
) );

$Item->locale_temp_switch(); // temporarily switch to item's locale

// display "more" link (read more/follow up)
$Item->more_link( array(
	'force_more' => false,
	'before' => '<p class="bMore">',
	'after' => '</p>',
	'link_text' => T_('Read more').' &raquo;',
	'anchor_text' => '<p class="bMore">'.T_('Follow up:').'</p>',
	'disppage' => '#',
	'format' => 'htmlbody',
) );

// displays message form link to item's author
$Item->msgform_link( array(
	'before' => '',
	'after' => ' ',
	'text' => T_('Send email to post author'),
	'title' => '#',
	'class' => '',
	'format' => 'htmlbody',
	'form_url' => '#current_blog#',
) );

// display links to pages for multi-page items
$Item->page_links( array(
	'before' => '<p>'.T_('Pages:').' ',
	'after' => '</p>',
	'separator' => ' ',
	'single' => '',
	'current_page' => '#',
	'pagelink' => '%d',
	'url' => '',
) );

// display the item's permalink
$Item->permanent_link( array(
	'before' => '',
	'after' => '',
	'text' => '#',
	'title' => '#',
	'class' => '',
) );

// display a link to 'publish NOW' an item if user has edit rights
$Item->publish_link( array(
	'before' => '',
	'after' => ' ',
	'text' => get_icon( 'publish', 'imgtag' ).' '.T_('Publish NOW!'),
	'title' => T_('Publish now using current date and time.'),
	'class' => '',
	'glue' => '&amp;',
	'save_context' => true,
) );

// typical use shown ... 
?>
<div class="post post_<?php $Item->status_raw(); ?>">
<?php

// display the item's tags
$Item->tags( array(
	'before' => '<div>'.T_('Tags').': ',
	'after' => '</div>',
	'separator' => ', ',
	'links' => true,
) );

// display and link item title
$Item->title( array(
	'before' => '',
	'after' => '',
	'format' => 'htmlbody',
	'link_type' => '#',
) );

// URL link, if the post has one
$Item->url_link( array(
	'before' => ' ',
	'after' => ' ',
	'text_template' => '$url$',
	'url_template' => '$url$',
	'target' => '',
	'format' => 'htmlbody',
	'podcast' => '#',
	'before_podplayer' => '<div class="podplayer">',
	'after_podplayer' => '</div>',
) );

// display item's view count
$Item->views( array(
	'before' => '',
	'after' => '',
	'zero_views' => '#',
	'one_view' => '#',
	'more_views' => '#',
) );

// display word count
$Item->wordcount( array(
	'before' => '',
	'after' => '',
) );

add_js_for_toolbar(); // registers javascripts for the navbar

debug_info(); // output debug info if requested

// display a message if list is empty
display_if_empty( array(
	'before' => '<p class="msg_nothing">',
	'msg_empty' => T_('Sorry, there is nothing to display...'),
	'after' => '</p>',
) );

header_content_type(); // sets charset

include_headlines(); // output collected <head> lines

// prev/next links in single post mode
item_prevnext_links( array(
	'template' => '$prev$$next$',
	'prev_start' => '',
	'prev_text' => '&laquo; $title$',
	'prev_end' => '',
	'prev_no_item' => '',
	'next_start' => '',
	'next_text' => '$title$ &raquo;',
	'next_end' => '',
	'next_no_item' => '',
	'block_start' => '',
	'block_end' => '',
) );

locale_restore_previous(); // restores previous locale

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// good times with Item goes here :)
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center">',
	'block_end' => '</p>',
	'block_single' => '',
	'links_format' => '$prev$ $first$ $list_prev$ $list$ $list_next$ $last$ $next$',
	'page_url' => '',
	'prev_text' => '&lt;&lt;',
	'next_text' => '&gt;&gt;',
	'no_prev_text' => '',
	'no_next_text' => '',
	'list_prev_text' => '...',
	'list_next_text' => '...',
	'list_span' => 11,
	'scroll_list_range' => 5,
) );

// messages generated from actions
messages( array(
	'block_start' => '<div class="action_messages">',
	'block_end' => '</div>',
) );

meta_generator_tag(); // for QP's stats

// title for the current request
request_title( array(
	'auto_pilot' => 'none',
	'title_before' => '',
	'title_after' => '',
	'title_none' => '',
	'title_single_disp' => true,
	'title_single_before' => '#',
	'title_single_after' => '#',
	'title_page_disp' => true,
	'title_page_before' => '#',
	'title_page_after' => '#',
	'glue' => ' - ',
	'format' => 'htmlbody',
	'arcdir_text' => T_('Archive Directory'),
	'catdir_text' => T_('Category Directory'),
	'comments_text' => T_('Latest Comments'),
	'credits_text' => T_('Software Credits'),
	'feedback-popup_text' => T_('Feedback'),
	'mediaidx_text' => T_('Photo Index'),
	'msgform_text' => T_('Send an Email Message'),
	'profile_text' => T_('User Profile'),
	'subs_text' => T_('Subscriptions'),
	'user_text' => T_('User'),
) );

robots_tag(); // robots meta tag

template_base_tag(); // for css and img includes

template_content_meta(); // Content-Type meta tag

template_description_tag(); // description meta tag

template_keywords_tag(); // keywords meta tag

$Hit->log(); // log the hit on this page ?>
